;04.04.2024,9:21-10:00 start work draw chars
;04.04.2024,12:37-13:00 draw chess texture
;05.04.2024,6:14-6:32 draw maps,add variables
;05.04.2024,7:17-7:26 invert cursor+charXY() | 8:49-8:57 cursor
;05.04.2024,10:22-10:51 keyboard left done
;06.04.2024,06:30-07:04 horisontal scroll done
;06.04.2024,7:53 mixing routine
;06.04.2024,10:27-10:41 check if done routine
;07.04.2024 7:16-7:20 improve mix REMOVE IT due to max iterations
;17.04 2024 7:06-7:47 player etc
;17.04 2024 13:36 final

	device zxspectrum128
        ORG #6000
begin
fieldt	equ $C000
rndb	equ fieldt+256
	ld a,$10,bc,$7ffd:out (c),a

	ld sp,$5FFF
;setup music & interrupt
	ld hl,song:call INIT
	di
	ld hl,$BE00,de,$BE01,bc,257,(hl),$BF:ldir
	ld a,$C3,($BFBF),a
	ld hl,intvec,($BFBF+1),hl
	ld a,$BE,i,a
	im 2
	ei
	xor a:out ($FE),a

;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir;debug grid

gamestart:
	call blackscr
;title
	ld ix,t1:call tout
	ld ix,t2:call tout
	ld ix,t3:call tout
	ld ix,t4:call tout
	ld ix,t5:call tout

kb_lp:
;key S
	ld a,$FD:in a,($FE):and 2:jp z,start_play
;key C
	ld a,$FE:in a,($FE):and 8:jp z,sel_control
;key G
	ld a,$FD:in a,($FE):and 16:jp z,game_siz

;key 1-5
	ld a,$F7
	in a,($FE)
	cpl
	and 31
	jr z,key6_0
	ld hl,keys1-1
gklp:
	inc hl
	rra
	jr nc,gklp
	ld a,(hl)
	call scrolld
	ld ix,t2:call tout
	call wp
	jp kb_lp

key6_0:
;key 6-0
	ld a,$EF
	in a,($FE)
	cpl
	and 31
	jp z,kb_lp
	ld hl,keys2-1
gklp2:
	inc hl
	rra
	jr nc,gklp2
	ld a,(hl)
	call scrolld
	ld ix,t2:call tout
	call wp
	jp kb_lp

scrolld: ; scroll digits
;	jr $
	ld de,(t2d)
	ld e,d,d,a
	ld hl,$3030
	or a:sbc hl,de
	ld a,h:or l:ret z
doscroll:
	ld (t2d),de
	ret
keys1:db "12345"
keys2:db "09876"

ctype:db 0 ; control type

game_siz:
	ld a,(gametype)
	inc a
	cp 3:jr nz,nogslp
	xor a
nogslp:
	ld (gametype),a
;copy name
	add a,$32
	ld (t5t),a
	ld (t5t+2),a
	ld ix,t5:call tout
	call wp
	jp kb_lp
sel_control:
	ld a,(ctype)
	inc a
	cp 3:jr nz,noclp
	xor a
noclp:
	ld (ctype),a
	ld l,a,h,0
	ld de,hl
	add hl,hl
	add hl,de
	ld de,controlt
	add hl,hl
	add hl,de
	ld de,t3c
	ld bc,6
	ldir
	ld ix,t3:call tout
	call wp
	jp kb_lp
controlt
	db "Cursor"
	db "67890 "
	db "QAOPM "
;cursor: port/bit
kbtbl:
 db $F7,16;5-left
 db $Ef,4;8-right
 db $EF,8;7-up
 db $EF,16;6-down
 db $Ef,1;0-fire
;if2 6 (left), 7 (right), 8 (down), 9 (up) and 0 (fire)
 db $EF,16;6-left
 db #EF,8;7-right
 db $EF,2;9-up
 db $EF,4;8-down
 db $EF,1;0-fire
;OPm
 db $DF,2;O-left
 db $DF,1;P-right
 db $FB,1;Q-up
 db $FD,1;A-down
 db $7F,4;M-fire
;-------------------------------------------
start_play:
	call blackscr
;tune keyboard ctype #,kbtbl
	ld hl,(ctype),h,0,de,hl
;*10
	add hl,hl;*2
	add hl,hl;*4
	add hl,de;*5
	add hl,hl;*10
	ld de,kbtbl
	add hl,de
;write data
	ld a,(hl),(klp+1),a:inc hl;left
	ld a,(hl),(klb+1),a:inc hl
	ld a,(hl),(krp+1),a:inc hl;right
	ld a,(hl),(krb+1),a:inc hl
	ld a,(hl),(kup+1),a:inc hl;up
	ld a,(hl),(kub+1),a:inc hl
	ld a,(hl),(kdp+1),a:inc hl;down
	ld a,(hl),(kdb+1),a:inc hl
	ld a,(hl),(kfp+1),a:inc hl;fire
	ld a,(hl),(kfb+1),a:inc hl

;count mixing#
	ld a,(t2d)
	sub $30
	ld b,a
	add a,a ; *2
	add a,a ; *4
	add a,b ;*5
	add a,a ; *10
	ld b,a
	ld a,(t2d+1)
	sub $30
	add a,b
	ld (mixc+1),a
;init variables
	ld hl,fieldt
zm: ld (hl),0:inc l:jr nz,zm
	ld a,1,(horizf),a

zz:
;starting position
	ld de,startpos_t:call getvar
	ld (px),hl

;draw board
	ld de,drawproc_t:call getvar
	call jphl

	call horiz_crs

milp:
	call mixing
	call chk;Z=0 if equal,Z=1 if not
	jr z,milp

;	jp game_end
;ws: ld a,$7f:in a,($FE):rra:jr c,ws
;ws1: ld a,$7f:in a,($FE):rra:jr nc,ws1
; jp zz
;starting position AGAIN
	ld de,startpos_t:call getvar
	ld (px),hl
;;;;;;;;;;;;;;;;;;; GAME LOOP ;;;;;;;;;;;;;;;;;;;
gamelp:
klp:	ld a,$F7; 5 left
	in a,($FE)
klb:	and 16
	jp nz,keyr
	ld a,(horizf)
	or a:jr z,hscrol1
;move cursor horisontal position
	ei:halt:halt:halt:halt
	call horiz_crs
;	jr $
	ld de,horiz_max:call getvar
	ld a,(px)
	cp h
	jr nz,dec_left
	ld a,l
;	inc a
dec_left:
	dec a
	ld (px),a
	call horiz_crs
	jp gamelp
hscrol1:
	ld b,4
lfl1
	ei:halt:halt
	push bc
	call sc_lf
	pop bc
	djnz lfl1
	call chk
	;jr z,$
	jp z,game_end
	jp gamelp
keyr:
krp:	ld a,$EF ; 8 right
	in a,($FE)
krb:	and 4
	jp nz,keyu
	ld a,(horizf)
	or a:jr z,hscrol2
;move cursor horisontal position
	ei:halt:halt:halt:halt
	call horiz_crs
;	jr $
	ld de,horiz_max:call getvar
	dec l ;????
	ld a,(px)
	cp l
	jr nz,dec_r
	ld a,h
	dec a
dec_r:
	inc a
	ld (px),a
	call horiz_crs
	jp gamelp
hscrol2:
	ld b,4
lfl2
	ei:halt:halt
	push bc
	call sc_rt
	pop bc
	djnz lfl2

	call chk
;	jr z,$
	jp z,game_end
	jp gamelp

keyu:
kup:	ld a,$EF ;7 up
	in a,($FE)
kub:	and 8
	jp nz,keyd
	ld a,(horizf)
	or a:jr nz,vscrol1
;move cursor horisontal position
	ei:halt:halt:halt:halt
	call vert_crs
	ld de,vert_max:call getvar
	ld a,(py)
	cp l
	jr nz,dec_u
	ld a,h
	inc a
dec_u:
	dec a
	ld (py),a
	call vert_crs
	jp gamelp
vscrol1:
	ld b,4
vsul1
	ei:halt:halt
	push bc
	call vs_up
	pop bc
	djnz vsul1
	call chk
;	jr z,$
	jp z,game_end
	jp gamelp

keyd ; 6 down
kdp:	ld a,$EF
	in a,($FE)
kdb:	and 16
	jp nz,keyf
	ld a,(horizf)
	or a:jr nz,vscrol2
;move cursor horisontal position
	ei:halt:halt:halt:halt
	call vert_crs
	ld de,vert_max:call getvar
	ld a,(py)
;	jr $
	cp h
	jr nz,dec_d
	ld a,l
	dec a
dec_d:
	inc a
	ld (py),a
	call vert_crs
	jp gamelp
vscrol2:
	ld b,4
vsul2
	ei:halt:halt
	push bc
	call vs_dn
	pop bc
	djnz vsul2

	call chk
;	jr z,$
	jp z,game_end
	jp gamelp

keyf: ;Enter
kfp:	ld a,$BF ; EF
	in a,($FE)
kfb:	and 1
	jp nz,gamelp
	call horiz_crs
	call vert_crs
	ld a,(horizf)
	xor 1
	ld (horizf),a
	call wp
	jp gamelp
wp: xor a:in a,($FE):cpl:and 31:jr nz,wp
	ret
game_end:
	ld ix,wd:call tout

	ld c,0
ge_lp:
;----------------------------------------
hu:
	ei:halt:halt:halt:halt:halt
	push bc
	ld ix,tt;wd+2
	LD DE,$486B
tlp:
	ld l,(ix+0):inc ix
;	jr $
	push de
	ld h,0,de,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	
	bit 0,c:jr nz,nochar
	dec hl;,hl
nochar:
;	inc hl
	pop de
	push de
chlp:
	ld a,(hl),(de),a
	inc hl,d
	ld a,d
	and 7
	jr nz,chlp
	pop de
	inc e
	inc c
	ld a,(ix+0)
	or a
	jr nz,tlp
	pop bc
	inc c
;----------------------------------------
	xor a
	in a,($FE)
	cpl
	and 31
	jp z,ge_lp
	
	jp gamestart
tt: db "Well done!",0
;inccolr:
;	ld a,c
;	inc a
;	cp 8
;	jr nz,nolpc
;	ld a,2
;nolpc:
;	ld c,a
;	ret
;-----------  VARS  -----------
px:db $0C ; for 2x2
py db $07 ; dy=9

gametype db 0 ; 0-2x2,1-3x3,2-4x4
horizf db 1 ; horisontal/vertical

lsize_t dw 8,12,16
horiz_max dw $0C14,$0A16,$0818 ; min.max
vert_max dw $0F08,$1106,$1304 ; max.min
horizy_t dw $0709,$050D,$0311 ; horizontal y.dy
horizx_t dw $0B09,$090D,$0711 ; horizontal x.dx
startpos_t  dw $080c,$060A,$0408 ; game start cursor position y.x
drawproc_t dw draw2x2,draw3x3,draw4x4 ; draw board routines
rnd_t dw $0810,$0C18,$1020;length.2*len
;color values
table2x2
 db 2,4,1,7
table3x3
 db $42,$16,4
 db 4+7*8,8+5,$45
 db $47,$46,$58
table4x4
 db $43,18,2,$40+7*9
 db $47,7,$45+7*8,$48+4
 db $48,$6+3*8,15,$56
 db $46,$44+32,4*9,$44
;-----------ROUTINES-----------
blackscr:
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
	ret
wd:
 dw $486B
 db "Well done!",$FF
 
t1:
	dw $4005
	db 6,"Cubulus ",7,"g0blinish ",4,"2o24",$FF
t2:
	dw $4823
	db "Mixing Level",6,"(press 0-9):",4
t2d db "01",$FF

t3:
	dw $4869
	db 7,"C",4,"ontrol:",6
t3c db "Cursor",$FF

t4:
	dw $48EB
	db 7,"S",4,"tart game",$FF

t5: dw $48A9
	db 7,"G",4,"ame size: ",6
t5t: db "2x2",$FF
tout: ;in:IX=address of message
	ld e,(ix+0):inc ix
	ld d,(ix+0):inc ix
	ld c,#47
tolp1:
	ld a,(ix+0):inc ix
	cp $ff:ret z
	cp 8:jr nc, putchar
	or $40
	ld c,a
	jr tolp1
putchar:
	ld l,a,h,0
	push bc
	ld bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	pop bc
	ld b,8
	push de
tolp2:
	ld a,(hl),(de),a:inc hl,d:djnz tolp2
	pop de
;put attribute
	ld l,e
;$40=01 000 000 $58=01011 000
;$48=01 001 000 $59=01011 001
;$50=01 010 000 $5A=01011 010
	ld a,d
	srl a
	srl a
	srl a
	and 7
	add a,$58
	ld h,a
	ld (hl),c
	inc e
	jr tolp1

intvec:
	push ix
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop ix
	ei:ret


jphl jp(hl)

chk: ;check equal field
;	jr $
	ld de,lsize_t:call getvar
	ld c,l,b,l
	ld de,startpos_t:call getvar
	ex de,hl
	call attrxy
	ld de,fieldt
chy:
	push bc,hl
chx:
	ld a,(de)
	cp (hl)
	jr z,nxtchk
	pop hl,bc
	ret
nxtchk: inc hl,de
	djnz chx
	pop hl
	ld bc,32
	add hl,bc
	pop bc
	dec c
	jr nz,chy
	ret
mixing ; mix board
;zero buffer
;;	ld hl,rndb
;;zb:ld (hl),0:inc l:jr nz,zb

mixc:	ld b,3;+4
mixlp:
	push bc
	ld de,rnd_t:call getvar
	push hl
	pop bc; B=max/2,C=max value
getrnd:
	call rnd
;check if exist
;	ld h,rndb/256,l,a
;	inc (hl):dec (hl):jr nz,getrnd
;	ld (hl),1
	cp b ;C=1 if arg1>=A, C=0 if arg1<A
	jr nc,vertm
;horisontal
	ld c,a
	ld de,startpos_t:call getvar
	ld a,l
	add a,c
	ld (px),a
	call random
	and 1
	jr nz,scdn
	ld hl,vs_up
	jr ssdd
;	call vs_up
;	call vs_up
;	call vs_up
;	call vs_up
;	jr nextmix
scdn
;	call vs_dn
;	call vs_dn
;	call vs_dn
;	call vs_dn
;	jr nextmix
	ld hl,vs_dn
	jr ssdd
vertm:
	sub b
	ld c,a
	ld de,startpos_t:call getvar
	ld a,h
	add a,c
	ld (py),a
	call random
	and 1
	jr nz,scup
;	call sc_rt
;	call sc_rt
;	call sc_rt
;	call sc_rt
;	jr nextmix
	ld hl,sc_rt
	jr ssdd
scup
;	call sc_lf
;	call sc_lf
;	call sc_lf
;	call sc_lf
	ld hl,sc_lf
ssdd
;	ld b,4
; select amount
	call random
	and 1
	push hl
	ld l,a
	add a,a
	add a,l
	ld l,a,h,0
	ld de,shft_t
	add hl,de
	ld de,(gametype),d,0
	add hl,de
	ld a,(hl)
	add a,a
	add a,a
	ld b,a
	pop hl
	ei:halt
dosu
	push bc,hl
	call jphl
	pop hl,bc
	djnz dosu
	
nextmix:
;	jr $
	pop bc
	dec b
	jp nz,mixlp
	ret
rnd
	call random
gm
	sub c
	jr nc,gm
	add a,c
	ret
shft_t
;0 1 2
 db 1,1,2
 db 1,2,3
random  PUSH BC:LD A,(R1),C,A
        LD A,(R2):ADD A,C:LD C,A
        LD (R1),A,A,(R3)
        SUB C:LD C,A,(R2),A
        RRCA:LD (R3),A
        LD A,C:POP BC
        RET
R1      DB #15
R2      DB #70
R3      DB #FD

sc_rt: ; scroll right
	ld de,lsize_t:call getvar
	ld c,l
	dec c
	ld de,startpos_t:call getvar
	ld de,(px)
	ld e,l

;	ld l,d ;Y
;	add hl,hl
;	add hl,hl
;	add hl,hl
;
;	ld h,22
;	add hl,hl
;	add hl,hl
;	ld d,0
;	add hl,de
	call attrxy
	ld b,0
	add hl,bc
	push hl
	pop ix
	ld b,c
	ld c,(ix+0)
scrl1:
	ld a,(ix-1)
	ld (ix+0),a
	dec ix
	djnz scrl1
	ld (ix+0),c
	ret
	
sc_lf: ; scroll left
	ld de,lsize_t:call getvar
	ld c,l
	ld de,startpos_t:call getvar
	ld de,(px)
	ld e,l
	
;	ld l,d ;Y
;	add hl,hl
;	add hl,hl
;	add hl,hl
;	
;	ld h,22
;	add hl,hl
;	add hl,hl
;	ld d,0
;	add hl,de
	call attrxy
	push hl
	pop ix
	
	ld b,c
	ld c,(ix+0)
sclp:
	ld a,(ix+1)
	ld (ix+0),a
	inc ix
	djnz sclp
	ld (ix-1),c
	ret
vs_dn: ;scroll down

	ld de,lsize_t:call getvar
	ld b,l
	ld de,startpos_t:call getvar
	ld de,(px)
	ld d,h
	ld a,d:add a,b:ld d,a
	dec d
;	ld l,d ;Y
;	add hl,hl
;	add hl,hl
;	add hl,hl
;	
;	ld h,22
;	add hl,hl
;	add hl,hl
;	ld d,0
;	add hl,de
	call attrxy
	push hl
	pop ix
	ld de,-32
	ld c,(ix+0)

;	ld (ix+0),$8e
;	ret
vsdlp
	ld a,(ix-32)
	ld (ix+0),a
	add ix,de
	djnz vsdlp
	ld (ix+32),c
	ret

vs_up: ;scroll up
	ld de,startpos_t:call getvar
	ld de,(px)
	ld d,h

;	ld l,d ;Y
;	add hl,hl
;	add hl,hl
;	add hl,hl
;	
;	ld h,22
;	add hl,hl
;	add hl,hl
;	ld d,0
;	add hl,de
	call attrxy
	push hl
	pop ix
	ld de,lsize_t:call getvar
	ld b,l
	ld c,(ix)
	ld de,32

;	ld (ix+0),$8e
;	ret
vsulp:
	ld a,(ix+32)
	ld (ix+0),a
	add ix,de
	djnz vsulp
	ld (ix-32),c
	ret
horiz_crs
	push hl
	ld de,horizy_t:call getvar
	ld de,(px)
	ld d,h
	push hl
	call charxy,crs
	pop hl
	ld a,d:add a,l:ld d,a
	call charxy,crs
	pop hl
	ret
vert_crs
	push hl
	ld de,horizx_t:call getvar
	ld de,(px)
	ld e,h
	push hl
	call charxy,crs
	pop hl
	ld a,e:add a,l:ld e,a
	call charxy,crs
	pop hl
	ret
getvar ; in: DE=table, out: HL=Value
	push af
	ld hl,(gametype),h,0
	add hl,hl
	add hl,de
	ld a,(hl):inc hl
	ld h,(hl),l,a
	pop af
	ret
draw4x4
	 ld de,#4008+3*32,hl,chars,c,16
	 exx
	 ld hl,$5808+3*32
	 exx
	 call linedraw

	 ld de,#5048+2*32,hl,chars+8,c,16
	 exx
	 ld hl,$5A48+2*32
	 exx
	 call linedraw

	 ld de,#4007+4*32,hl,chars+24,c,16
	 exx
	 ld hl,$5807+4*32
	 ld de,32
	 exx
	 call vdraw

	 ld de,#4008+4*32+16,hl,chars+16,c,16
	 exx
	 ld hl,$5808+16+4*32
	 ld de,32
	 exx
	 call vdraw

	 ld hl,$4008+4*32,bc,$1080:call chessdraw
;fill table with colors
	ld ix,table4x4,bc,$0404:call fillf
;	ld de,$5808+4*32
;	ld bc,$1010
	call copy2x2;copy to screen

;draw map
	ld hl,#5080,bc,$0420:call chessdraw
	ld ix,table4x4
	ld hl, $5A80
	ld bc,$404; B=width,C=height
	jp atrmap

draw3x3
	 ld de,#400A+5*32,hl,chars,c,12
	 exx
	 ld hl,$580A+5*32
	 exx
	 call linedraw
;
	 ld de,#504A,hl,chars+8,c,12
	 exx
	 ld hl,$5A4A
	 exx
	 call linedraw

	 ld de,#4009+6*32,hl,chars+24,c,12
	 exx
	 ld hl,$5809+6*32
	 ld de,32
	 exx
	 call vdraw

	 ld de,#400A+6*32+12,hl,chars+16,c,12
	 exx
	 ld hl,$580A+12+6*32
	 ld de,32
	 exx
	 call vdraw

	 ld hl,$400A+6*32,bc,$0C60:call chessdraw
;fill table with colors
	ld ix,table3x3,bc,$0303:call fillf
;	ld de,$580A+6*32
;	ld bc,$0C0C
	call copy2x2;copy to screen

;draw map
	ld hl,#50A0,bc,$0318:call chessdraw
	ld ix,table3x3
	ld hl, $5AA0
	ld bc,$303; B=width,C=height
	jp atrmap

draw2x2
	 ld de,#400c+7*32,hl,chars,c,8
	 exx
	 ld hl,$580c+7*32
	 exx
	 call linedraw

	 ld de,#500c,hl,chars+8,c,8
	 exx
	 ld hl,$5A0C
	 exx
	 call linedraw

	 ld de,#480B,hl,chars+24,c,8
	 exx
	 ld hl,$590b
	 ld de,32
	 exx
	 call vdraw

	 ld de,#480C+8,hl,chars+16,c,8
	 exx
	 ld hl,$590C+8
	 ld de,32
	 exx
	 call vdraw
	 
	 ld hl,$480c,bc,$0840:call chessdraw
;fill table with colors
	ld ix,table2x2,bc,$0202:call fillf

;	ld de,$590c
;	ld bc,$0808
	call copy2x2;copy to screen
;draw map
	ld hl,#50C0,bc,$0210:call chessdraw
	ld ix,table2x2
	ld hl, $5AC0
	ld bc,$202; B=width,C=height
	jp atrmap

crs
	push af,bc,hl
	ld b,8
crlp:
	ld a,(hl):cpl:ld (hl),a
	inc h:djnz crlp
	pop hl,bc,af
	ret
	
charxy ;in: D=y,E=x, out: HL=screen address
	push de
	ld	hl, 4000h
	ld	a, d
	and	18h
	or	h
	ld	h, a
	ld	a, d
	and	7
	ld	d, a
	srl	d
	rr	l
	srl	d
	rr	l
	srl	d
	rr	l
	add	hl, de
	pop de
	ret
atrmap
amlp
	push hl,bc
amlp2:
	ld a,(ix+0):inc ix
	ld (hl),a:inc hl
	djnz amlp2
	pop bc,hl
	ld de,32:add hl,de
	dec c
	jr nz,amlp
	ret

attrxy : ;in:D=y,E=x,out:HL=attribute addresss
	ld l,d ;Y
	add hl,hl
	add hl,hl
	add hl,hl
	
	ld h,22
	add hl,hl
	add hl,hl
	ld d,0
	add hl,de
	ret
copy2x2
;	jr $
	ld de,lsize_t:call getvar
	ld c,l,b,l
	ld de,startpos_t:call getvar
	ex de,hl
	call attrxy
	ex de,hl
	ld hl,fieldt
;	ld de,$590c
;	ld bc,$0808
copylp:
	push bc,de
	ld b,0
	ldir
	pop de
	ld bc,32
	ex de,hl
	add hl,bc
	ex de,hl
	pop bc
	djnz copylp
	ret
fillf
	ld hl,fieldt
	ld d,b
fiylp
	ld e,4
	push ix
	push bc
fixlp2:
	push ix
	push bc
fixlp
	ld a,(ix+0):inc ix
	ld (hl),a:inc hl
	ld (hl),a:inc hl
	ld (hl),a:inc hl
	ld (hl),a:inc hl
	dec c:jr nz,fixlp
	pop bc
	pop ix
	dec e
	jr nz,fixlp2
	pop bc
	pop ix
	ld b,0
	add ix,bc
	dec d
	jr nz,fiylp
	ret
	
chessdraw ; ib:HL=address,B=width, C=height
	ld e,$aa
chylp:
	push hl,bc
chxlp:
	ld (hl),e:inc hl:djnz chxlp
	pop bc,hl
	call nbhl
	rrc e
	dec c
	jr nz,chylp
	ret
nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET

vdraw
vdlp:
	push hl,de
	ld b,8
vdl1
	ld a,(hl),(de),a
	inc hl,d
	djnz vdl1
	exx
	ld (hl),$47
	add hl,de
	exx
	pop de,hl
	ld a,e
	add a,32
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	dec c
	jr nz,vdlp
	ret

linedraw
ldlp:
	push hl,de
	ld b,8
ldl1:
	ld a,(hl),(de),a
	inc hl,d
	djnz ldl1
	exx
	ld (hl),$47:inc hl
	exx
	pop de,hl
	inc e
	dec c
	jr nz,ldlp
	ret
chars
 db 0,8,28,28,62,62,127,0;up
 db 0,127,62,62,28,28,8,0;down
 db 0,64,112,124,126,124,112,64 ;right
 db 0,2,14,62,126,62,14,2 ; left
 db 170,85,170,85,170,85,170,85 ; tile
 db 255,128,169,148,173,156,129,170 ; alt tile?
 db 0
fnt:incbin "Cubulus.fnt"
song:incbin "nq-Cubulus-rmx.pt3"
plyr:include "PTxPlay.a80"

end
	display /d,end-begin
	savesna "cubulus.sna",begin

	savebin "Cubulus.code",begin,end-begin